module Nestene
  class ExecutingMethod
    include StructureMapper::Hash

    def initialize(scheduled_method = nil)
      if scheduled_method
        self.name = scheduled_method.name
        self.parameters = scheduled_method.parameters
        self.uuid = scheduled_method.uuid
        self.scheduled_at = scheduled_method.scheduled_at
        self.started_at = Time.now
        self.callback = scheduled_method.callback
      end
    end

    attribute name: Symbol
    attribute parameters: []
    attribute uuid: String
    attribute scheduled_at: Time
    attribute started_at: Time
    attribute callback: Callback
  end
end