$LOAD_PATH << '.'
$LOAD_PATH << 'lib'

require 'nestene'

Dir.mkdir('storage') unless File.exists?('storage')

Nestene::start_nestene(Nestene::DiskStorage.new('storage'))

to_check = Bundler.load.specs.map(&:full_gem_path)
to_check << '.'

to_check.each do |path|
  file_name = "%s/autons.rb" % [path]
  if File.exists?(file_name)
    puts "loading %s" % file_name
    load(file_name)
  end
end

run Nestene::Ui::App
