module Nestene
    class AutonState

    include StructureMapper::Hash

    def initialize
      self.queue=AutonExecutionQueue.new
    end

    def state
      if queue.currently_executing == nil
        queue.failed ? :failed : :ready
      else
        :running
      end
    end

    attribute type: String
    attribute serialized: {}
    attribute queue: AutonExecutionQueue

    def type_as_class
      self.type ? Nestene::class_from_string(self.type) : nil
    end
  end

end