module Nestene
  class ScheduledMethod
    include StructureMapper::Hash

    def initialize(delayed_method = nil)
      self.parameters = []
      self.scheduled_at = Time.now
      if delayed_method
        self.uuid = delayed_method.uuid
        self.name = delayed_method.name
        self.parameters = delayed_method.parameters
      end
    end

    attribute name: Symbol
    attribute parameters: []
    attribute uuid: String
    attribute scheduled_at: Time
    attribute callback: Callback
  end
end